/*******************************************************************************

Copyright (c) 2003, Robert Cowham and Vaccaperna Systems Ltd.  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1.  Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.

2.  Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL VACCAPERNA SYSTEMS LTD. BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*******************************************************************************/

/*******************************************************************************
 * Name:	TraceUtils.cpp
 *
 * Author:	Robert Cowham <robert@vaccaperna.co.uk>
 *
 * Description: 
 *		A Tracing utility
 *
 ******************************************************************************/

#include "TraceUtils.h"

// Are we tracing or not?
BOOL Tracing()
{
	static BOOL Initialized = FALSE;
	static BOOL AreTracing = FALSE;

	if (!Initialized)
	{
		Initialized = TRUE;

		try
		{
			CRegKey Key;
			DWORD Val = 0;

			if (!Key.Open (HKEY_CURRENT_USER, _T("Software\\Perforce\\P4OFC")))
			{
#if _MSC_VER >= 1300	/* VC++ 7.0 or greater */
				Key.QueryDWORDValue (_T("DebugTrace"), Val);
#else
				Key.QueryValue (Val, _T("DebugTrace"));
#endif
				if (Val != 0) AreTracing = TRUE;
			}
			Key.Close();
		}
		catch (...)
		{
			LogException(_T("Tracing"));
		}
	}

	return AreTracing;
}

// This function is stolen from AtlTrace which gets #ifdef ed out if not in Debug mode...
void FormatTrace(LPCTSTR lpszFormat, ...)
{
	va_list args;
	va_start(args, lpszFormat);

	int nBuf;
	TCHAR szBuffer[512];

	nBuf = _vsntprintf(szBuffer, sizeof(szBuffer) - 1, lpszFormat, args);
	ATLASSERT(nBuf < sizeof(szBuffer)); //Output truncated as it was > sizeof(szBuffer)

	OutputDebugString(szBuffer);
	va_end(args);
}
